<?php
App::uses('EvShopAppModel', 'EvShop.Model');
/**
 * EvShopVariantPricing Model
 *
 * @property Variant $Variant
 * @property Currency $Currency
 * @property TaxLevel $TaxLevel
 */
class VariantPricing extends EvShopAppModel {

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'rrp' => array(
			'money' => array(
				'rule' => array('money'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'price' => array(
			'money' => array(
				'rule' => array('money'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'sale_price' => array(
			'money' => array(
				'rule' => array('money'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
	);

	// The Associations below have been created with all possible keys, those that are not needed can be removed

/**
 * belongsTo associations
 *
 * @var array
 */
	public $belongsTo = array(
		'Variant' => array(
			'className' => 'EvShop.Variant'
		)
	);

	/**
	 * redefine constructor to check for EvTax and EvCurrency
	 */
	public function __construct($id = false, $table = null, $ds = null) {
		if (CakePlugin::loaded('EvCurrency')) {
			$this->actsAs['EvCurrency.Currency'] = array(
				'formInject' => true
			);

			$this->belongsTo['Currency'] = array(
				'className' => 'EvCurrency.Currency',
				'foreignKey' => 'currency_id'
			);
		}

		if (CakePlugin::loaded('EvTax')) {
			$this->actsAs['EvTax.Taxable'] = array(
				'formInject' => true
			);

			$this->belongsTo['TaxLevel'] = array(
				'className' => 'EvTax.TaxLevel',
				'foreignKey' => 'tax_level_id'
			);

			$this->actsAs['EvTax.CalculateTax'] = array(
				'fields' => array(
					'rrp',
					'price',
					'sale_price',
					'trade_price'
				),
				'TaxRateModel' => 'EvShop.VariantPrice',
				'TaxRateModelId' => 'id'
			);
		}

		parent::__construct($id, $table, $ds);
	}
}
